#include "DHT.h"

DHT dht(2, DHT11);         // Pin 2 modtager fra DHT11
int sensorValue;              // Definer variabel til at gemme værdi 
int Vout;                     // Resultat sendes til analog udgang
float tid;                 // Tid i sekunder
int Tsoll;            // Ønsket temperatur
int fejl;             // Forskel mellem ønsket og aktuel temperatur
int oldfejl;          // Gamle værdi af fejl til D-kontrol
int dfejl;            // Ændring i fejl til D-kontrol
float Kp=12;          // Konstant til proportionalregulering
float Ki=0.1;         // Konstant til proportionalregulering
float Kd=0.1;         // Konstant til differentialregulering
float PIDp=0;         // Startværdi for P-kontrol
float PIDi=0;         // Startværdi for I-kontrol
float PIDd=0;         // Startværdi for D-kontrol
float PID;         

void setup() {               
  Serial.begin(9600);      // Sæt op til seriel kommunikation via USB
}

void loop() {
  
  int t = dht.readTemperature();     // Læs temperatur fra DHT11
 // check besked fra sensor er fornuftig. Hvis det ikke er tal (NaN, not a number) er der noget galt!
  if (isnan(t)) {
    Serial.println("Læsefejl fra DHT-sensor");
  } else
  {
 sensorValue=analogRead(A0);
 Tsoll=sensorValue/12;    // Ønsket værdi valgt til at være 1/12 af pot.meterværdi
 tid=millis()/1000.;      // Tid siden start
 oldfejl=fejl;            // Gemmer gamle fejl til D-kontrol
 fejl=Tsoll-t;            // Beregner aktuel fejl
 dfejl=fejl-oldfejl;      // Beregner ændring i fejl til D-kontrol
 PIDp=Kp*fejl;            // P-bidrag til styresignal
 PIDi=PIDi+Ki*fejl;       // I-bidrag
 PIDd=Kd*fejl;            // D-bidrag
 PID=PIDp+PIDi+PIDd;      // Samlet PID-signal
  
 Vout=8*sqrt(PID);        // Omregn til styresignal til effektforstærker
 analogWrite(5,Vout);     // Skriv til pin 5 (PWM)
  Serial.print(tid);      // Skriv tid til seriel monitor
  Serial.print("\t");          //  Tabulering
  Serial.print(sensorValue);   // Skriv den "rå" indgangsspænding læst af A0
  Serial.print("\t"); 
           
  Serial.print(PIDp);           
  Serial.print("\t");
  Serial.print(PIDi); 
  Serial.print("\t"); 
  Serial.print(PIDd);           
  Serial.print("\t");         
  Serial.print(PID);           
  Serial.print("\t");
  Serial.print(Vout);
  Serial.print("\t"); 
  Serial.print(Tsoll);     // Skriv ønsket temperatur (Sollwert)
  Serial.print("\t");   
  Serial.print(t);         // Skriv aktuel temperatur
  Serial.println();        //  Linjeskift

  delay(2000);             // forsinkelse mellem hver måling
  }
}
